Changes for Filter Effects specification
----------------------------------------

2013-11-15  Dirk Schulze  <dschulze@adobe.com>
- Resolve issues as per WG resolutions: http://www.w3.org/2013/11/15-svg-minutes.html

2013-11-14  Dirk Schulze  <dschulze@adobe.com>
- Remove preserveAlpha interface property of feConvolveMatrix by request of SVG WG.

2013-11-11  Dirk Schulze  <dschulze@adobe.com>
- CSS WG decision: Graphical effects, including filter effects, do filter UI.

2013-11-10  Dirk Schulze  <dschulze@adobe.com>
- Defer issue about filtering multiple levels to a later spec.

2013-11-07  Dirk Schulze  <dschulze@adobe.com>
- Add informative references to security studies.
- Add detailed description of potential security risks by filter primitives.

2013-11-04  Dirk Schulze  <dschulze@adobe.com>
- Add href to feImage and clarify interaction with xlink:href (later deprecated now)
- Removed filterRes attribute after WG decision.

2013-10-31  Dirk Schulze  <dschulze@adobe.com>
- Resolve issues clarfied in SVG WG meetings on filter functions.

2013-10-07  Dirk Schulze  <dschulze@adobe.com>
- Add 'crossorigin' attribute to feImage.

2013-09-26  Dirk Schulze  <dschulze@adobe.com>
- Added validation guidance for custom shaders and extended security module.

2013-09-26  Dirk Schulze  <dschulze@adobe.com>
- First attempt to write the security section. This sections is currently work in progress.

2013-09-06  Dirk Schulze  <dschulze@adobe.com>
- Allow <string> in CSS image filter() function to match behavior on other CSS Images.

2013-08-31  Dirk Schulze  <dschulze@adobe.com>
- Added edgeMode attribute to feGaussianBlur
- Specify that edgeMode computes to 'none' for 'filter' property
  and 'duplicate' for filter() CSS Image function.

2013-08-26  Dirk Schulze  <dschulze@adobe.com>
- Replace SVGAnimatedColor with SVGAnimatedString.

2013-08-26  Dirk Schulze  <dschulze@adobe.com>
- Added clarification for 'color-interpolation-filters' property.

2013-08-26  Dirk Schulze  <dschulze@adobe.com>
- Added more issues to the spec.

2013-08-25  Dirk Schulze  <dschulze@adobe.com>
- Added more issues to the spec.

2013-08-23  Dirk Schulze  <dschulze@adobe.com>
- Clean-up.

2013-08-22  Dirk Schulze  <dschulze@adobe.com>
- Clean-up. Remove hint about performance increase because of security concerns.

2013-08-17  Dirk Schulze  <dschulze@adobe.com>
- Specify filter() image function and interpolation.

2013-08-14  Dirk Schulze  <dschulze@adobe.com>
- Clarify interpolation behavior more.

2013-08-13  Dirk Schulze  <dschulze@adobe.com>
- Fix initial values for interpolation on grayscale, invert and sepia.

2013-08-05  Dirk Schulze  <dschulze@adobe.com>
- Clarify lacuna values for filter shorthands.
- Fix a bug with drop-shadow syntax.

2013-07-16  Dirk Schulze  <dschulze@adobe.com>
- Be more explicit on parsing instructions for filter functions.

2013-07-14  Dirk Schulze  <dschulze@adobe.com>
- Explicitly state allowed ranges and lacuna values for filter functions.

2013-07-09  Dirk Schulze  <dschulze@adobe.com>
- Just support one shadow item for drop-shadow in the first level.

2013-07-04  Dirk Schulze  <dschulze@adobe.com>
- Clarify that filter functions operate in sRGB
- Clarify interpolation between filter functions.

2013-07-04  Dirk Schulze  <dschulze@adobe.com>
- Add child selector as property value to filter property.

2013-07-04  Dirk Schulze  <dschulze@adobe.com>
- Dimension and origin of passed image to filter() CSS Image function must be preserved.

2013-06-12  Dirk Schulze  <dschulze@adobe.com>
- Removed support for 'enable-background' and require 'isolation' instead.

2013-06-08  Dirk Schulze  <dschulze@adobe.com>
- Corrected formulas for contrast changes. Detected by Kurosawa during #testTWF.

2013-05-23  Dirk Schulze  <dschulze@adobe.com>
- Switch order of index and property index.

2013-05-22  Dirk Schulze  <dschulze@adobe.com>
- Clarify that <defs> elements are not going to be masked/clipped.
- Added section about changes since the last publication.

2013-05-15  Dirk Schulze  <dschulze@adobe.com>
- Prepare specification for next WD (2).

2013-05-09  Dirk Schulze  <dschulze@adobe.com>
- Prepare specification for next WD.

2013-04-23  Dirk Schulze  <dschulze@adobe.com>
- Replace mix value none with auto.
- Clarify that Custom Shader is a host language for shaders
  and an extension of Custom Filter Function.
- Remove unnecessary shader uniforms.

2013-04-20  Dirk Schulze  <dschulze@adobe.com>
- Editorial changes.
- Replace texture with image function from CSS3 Images.

2013-04-10  Dirk Schulze  <dschulze@adobe.com>
- Editorial changes after the last edit.

2013-04-10  Dirk Schulze  <dschulze@adobe.com>
- Remove section about auto varying. Should be compatible to WebGL.

2013-04-10  Dirk Schulze  <dschulze@adobe.com>
- Remove a_texCoord, a_mesCoord, u_tileSize, u_projectionMatrix variables and attributes.
These turned out to be implementation specifics that can be abstracted more from the user.
- The shader coordinate system changes to a range from [0,1] for better compatibility to WebGL.

2013-04-10  Dirk Schulze  <dschulze@adobe.com>
- Remove u_meshBox from spec. With the removal of <box> argument for
shaders not necessary anymore.

2013-03-26  Dirk Schulze  <dschulze@adobe.com>
- Clarify relation of 'enable-background' and 'isolation' properties.

2013-03-15  Dirk Schulze  <dschulze@adobe.com>
- Underline that the texture uniform is in device pixel.

2013-03-12  Dirk Schulze  <dschulze@adobe.com>
- Add conformance section.

2013-03-08  Dirk Schulze  <dschulze@adobe.com>
- Fixed typos. Added issue to support previous filter primitive
  for custom filter.

2013-02-28  Dirk Schulze  <dschulze@adobe.com>
- Added attribute description to feCustomSource element.

2013-02-27  Dirk Schulze  <dschulze@adobe.com>
- Added interface for feCustomParam element.

2013-02-27  Dirk Schulze  <dschulze@adobe.com>
- Style clean up. Bug fixes.

2013-02-27  Dirk Schulze  <dschulze@adobe.com>
- Fix issues with drop-shadow.
  (https://www.w3.org/Bugs/Public/show_bug.cgi?id=20762)

2013-02-26  Dirk Schulze  <dschulze@adobe.com>
- Enable automatic line break for math formulas.

2013-02-26  Dirk Schulze  <dschulze@adobe.com>
- Use MathJax for representing the (now) inline MathML formulas.

2013-02-26  Dirk Schulze  <dschulze@adobe.com>
- Use image references with <img> instead of <object>.

2013-01-26  Dirk Schulze  <dschulze@adobe.com>
- Define @support condition for custom filter extensions.
- Define margin descriptor on custom filters.

2013-01-26  Dirk Schulze  <dschulze@adobe.com>
- Fixed interfaces:
  https://www.w3.org/Bugs/Public/show_bug.cgi?id=20781
  https://www.w3.org/Bugs/Public/show_bug.cgi?id=20782

2013-01-15  Dirk Schulze  <dschulze@adobe.com>
- Remove implementing of SVGTest as discussed on SVG WG meeting of 01-10-2013.

2013-01-14  Dirk Schulze  <dschulze@adobe.com>
- 0% on contrast makes the image gray, not black.
  https://www.w3.org/Bugs/Public/show_bug.cgi?id=19712

2013-01-14  Dirk Schulze  <dschulze@adobe.com>
- Corrected issue with feComponentTransfer
  https://www.w3.org/Bugs/Public/show_bug.cgi?id=20658
- Added issue about adding amount transformation function on brightness and contrast filter functions.

2013-01-13  Dirk Schulze  <dschulze@adobe.com>
- More reorganizing for better orientation.
- Distinguish between custom filter resource format and custom filter type.
- Add Media Query Feature: filter.
- Clarifications on filter functions (meaning of opacity, added more issues).

2013-01-11  Dirk Schulze  <dschulze@adobe.com>
- Reorganize chapters for a better orientation.
- Modify @filter rule to simplify the syntax, make it more independent of shading languages.
- Lot of clean-up.

2012-11-16  Dirk Schulze  <dschulze@adobe.com>
- Start outlining how margin for custom-filters will look like.

2012-11-16  Dirk Schulze  <dschulze@adobe.com>
- Editorial changes to custom-filter at-rule.

2012-11-16  Dirk Schulze  <dschulze@adobe.com>
- First draft of the new custom-filter at-rule.

2012-11-08  Dirk Schulze  <dschulze@adobe.com>
- Add test suite information on spec.

2012-11-08  Dirk Schulze  <dschulze@adobe.com>
- Update normative and informative references.

2012-11-08  Dirk Schulze  <dschulze@adobe.com>
- Remove issue to hit testing. Filters won't effect hit testing, since it could lead to security issues.

2012-11-08  Dirk Schulze  <dschulze@adobe.com>
- Calrify that filters are applied in the element's local coordinate system.

2012-11-08  Dirk Schulze  <dschulze@adobe.com>
- Calrify that filter operations effect all portions of element drawing, including scroll bars.

2012-11-08  Dirk Schulze  <dschulze@adobe.com>
- Add new sections for module interactions.

2012-11-07  Dirk Schulze  <dschulze@adobe.com>
- Use 'fill' and 'stroke' property for FillPaint and StrokePaint on HTML elements.

2012-11-06  Dirk Schulze  <dschulze@adobe.com>
- Add interface defintion for feDropShadow.

2012-11-06  Dirk Schulze  <dschulze@adobe.com>
- Cleanup interface code and auto generate links.
- Remove ImageData interface and link to context2d (WD).

2012-11-05  Dirk Schulze  <dschulze@adobe.com>
- Start porting interface to WebIDL and SVG2.

2012-11-05  Dirk Schulze  <dschulze@adobe.com>
- Add 'feCustomParam' to add multiple parameters of different types.

2012-10-25  Dirk Schulze  <dschulze@adobe.com>
- Removed reference to RelaxNG. We use WebIDL for the interfaces. No validation code.
- Remove note about naming 'cudtom()', 'shader()'
- Remve feUnsharpen for now. Opened bug report if we want to have it later.
- Removed unspecified short hand functions. Opened bug report.
- Removed issue about new code for feTurbulence. We won't change the code in Filter Effects.
- Remve feDiffuseSpecularElement for now. Opened bug report if we want to have it later.

2012-10-21  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (9).

2012-10-03  Dirk Schulze  <dschulze@adobe.com>
- Modified note to issue to support more shading languages.
- Added normative references to GLSL ES and WebGL specs.

2012-08-20  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (8).

2012-08-20  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (7).

2012-08-20  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (6).

2012-08-18  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (5).

2012-08-18  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (4).

2012-08-17  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (3).

2012-08-17  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (2).

2012-08-17  Dirk Schulze  <dschulze@adobe.com>
- Preparation for publication (1).

2012-08-17  Dirk Schulze  <dschulze@adobe.com>
- Corrected typos and added issue to 'color-interpolation-filters' property.

2012-08-16  Dirk Schulze  <dschulze@adobe.com>
- Added issue to apply filters to just borders or backgrounds instead of just the whole group.
- Added me as editor.

2012-08-12  Dirk Schulze  <dschulze@adobe.com>
- Fix references to Compositing spec.

2012-08-10  Dirk Schulze  <dschulze@adobe.com>

- Add sentence to property interpolation.

2012-08-07  Dirk Schulze  <dschulze@adobe.com>

- Editorial changes of 'enable-background'

2012-08-07  Dirk Schulze  <dschulze@adobe.com>

- Added issue about how infinit inputs apply to feGaussianBlur and feMorphology.
- Fixed typo on infinite inputs for feGaussianBlur (end of sentence was missing).

2012-08-06  Dirk Schulze  <dschulze@adobe.com>

- custom primitive operates on non-premultiplied colors
- general typo fixes

2012-08-01  Dirk Schulze  <dschulze@adobe.com>

- more clean-up and link fixes

2012-08-01  Dirk Schulze  <dschulze@adobe.com>

- general clean-up
- fix links

2012-08-01  Dirk Schulze  <dschulze@adobe.com>

- update mix function description. It is independent from a specific shader language now.
- Updated the default shaders for GLSL.

2012-07-27  Dirk Schulze  <dschulze@adobe.com>

- update element summary of filter element after more changes from Cameron on the preprocessor

2012-07-27  Dirk Schulze  <dschulze@adobe.com>

- use preprocessor to create element summary

2012-07-23  Erik Dahlström  <ed@opera.com>

- ACTION-3314: Specify that float values in the 'order' attribute of feConvolveMatrix 
  will truncate the values if they're not integers.

2012-07-20  Dirk Schulze  <dschulze@adobe.com>

- corrections to shader part after review

2012-06-27  Dirk Schulze  <dschulze@adobe.com>

- corrections on mix function

2012-06-27  Dirk Schulze  <dschulze@adobe.com>

- added description of mix function in the processing model
- some tweaks to SVG images

2012-06-27  Dirk Schulze  <dschulze@adobe.com>

- again: use more SVG magic for shaders

2012-06-25  Dirk Schulze  <dschulze@adobe.com>

- use more SVG magic for shaders

2012-06-25  Dirk Schulze  <dschulze@adobe.com>

- added svg stack for shader concept - replaces PNGs

2012-06-25  Dirk Schulze  <dschulze@adobe.com>

- started adding shader processing model
- issue corrections on shader boxes

2012-06-22  Dirk Schulze  <dschulze@adobe.com>

- for now, the filter-margin properties just apply to filter function custom()

2012-06-22  Dirk Schulze  <dschulze@adobe.com>

- added index and property index
- cleanup of property defintions

2012-06-22  Dirk Schulze  <dschulze@adobe.com>

- added defintions for <box>
- cleanup of properties
- cleanup of defintions
- reordering of sections for a better readability

2012-06-21  Dirk Schulze  <dschulze@adobe.com>

- Added defintion for 'filter-margin(-bottom, -left. -right, -top)' properties

2012-06-20  Dirk Schulze  <dschulze@adobe.com>

- Change short hand to 'filter-effects' ny adding a link to TR state of spec

2012-06-20  Dirk Schulze  <dschulze@adobe.com>

- Cleanup of feCustom section

2012-06-20  Dirk Schulze  <dschulze@adobe.com>

- add description of mix function
- add first graphic for processing model of mix

2012-06-19  Dirk Schulze  <dschulze@adobe.com>

- added new paragraph about fragmentShader attribute

2012-06-19  Dirk Schulze  <dschulze@adobe.com>

- *-color properties follow the syntax of CSS Values and Units now

2012-06-19  Dirk Schulze  <dschulze@adobe.com>

- updated syntax for mix(..) function

2012-06-18  Dirk Schulze  <dschulze@adobe.com>

- updated property definition markup; Same like for CSS and SVG2 specs now
- added more information to head of spec

2012-06-18  Dirk Schulze  <dschulze@adobe.com>

- updated 'custom' syntax to latest proposal
- Fixed links to CSS3 Transforms; changed <css-3d-transform> to <transform-function>

2012-06-17  Dirk Schulze  <dschulze@adobe.com>

- make syntax of custom() and feCustom follow CSS Units and Values
- begin cleaning up feCustom section

2012-06-17  Dirk Schulze  <dschulze@adobe.com>

- add link to ChangeLog, similar to other specs

2012-06-17  Dirk Schulze  <dschulze@adobe.com>

- edit Makefile to use FXTF status text
- status of document is generated by W3C server now
- same for date of last edit
- copied images from CSS Shader to Filter Effects
- make use of 'issue' class for ISSUES

2012-05-07  Erik Dahlström  <ed@opera.com>

- Moved the 'color-interpolation-filters' property definition from the 
  painting chapter in SVG to here.

2012-03-28  Dean Jackson  <dino@apple.com>

- Restored all the examples, element definitions and IDL interfaces
  from previous version of the spec, which I had accidentally deleted
  when moving from the XML source.

2011-12-17  Dean Jackson  <dino@apple.com>

- Added a simple HTML redirection into publish/index.html since
  it's hard to find the new spec location.
- opacity() had values the wrong way around (should match CSS opacity)
- remove sharpen() effect (as resolved at TPAC)
- mention that hue-rotate should not normalize
- remove gamma() and replace with the more useful brightness() and contrast()
- blur() should only take one parameter to be more equivalent to CSS shadows

2011-11-05  Dean Jackson  <dino@apple.com>

- Change to new specification style. Archive some old content.
- Merged CSS Shaders proposal and Filter Effects. This
  included a number of small tweaks to the abstract and
  introduction sections.
- Added security section given background on timing attacks
  and cross-origin restrictions.
- 0-1 parameters for functions changed to 0%-100%
- Fixed grayscale and sepia functions (they were very wrong)

2011-10-14  Erik Dahlström  <ed@opera.com>

- Some minor tweaks of the intro section for FPWD publication
- Added link to SVG WG patent disclosures
- Clarified "Elements formatted by CSS"

2011-10-06  Dean Jackson  <dino@apple.com>

- Validation fixes for publication (nothing to see here)

2011-09-29  Erik Dahlström  <ed@opera.com>

- Removed the 0..1 range restriction in the values attribute on
  feColorMatrix with type="saturate".

2011-09-07  Dean Jackson  <dino@apple.com>

- Added opacity function
- Corrected luminanceToAlpha values

2011-08-31  Dean Jackson  <dino@apple.com>

- Remove commas from shorthand function parameter input.
- Rename unsharp() shorthand to sharpen()
- drop-shadow shorthand parameter is now a <shadow>

2011-08-30  Dean Jackson  <dino@apple.com>

- note that feCustom is probably not going to be included at this stage
- Added filter() <image> function
- Removed x y width height parameters from enable-background
- Added drop-shadow shorthand

2011-07  Erik Dahlström <ed@opera.com>

- Various changes. See hg log for details.

2011-04-18  Dean Jackson  <dino@apple.com>

- renamed files, removing "SVG"
- temporarily commenting out reqs and primer publication
- update the intro section to be more language neutral, and
  generally replace SVG with XML for now.
- define the filter property in terms of a list of function
- describe the functions as a space separated list
  of commands like url(), sepia() etc.
- show the equivalent XML version for each shorthand function
